/*
 * ast.h: abstract syntax tree for datadec
 *
 *      This module provides the internal structures needed
 *      for the data declaration builder.
 */

struct paramlist;
typedef struct paramlist *paramlist;
typedef paramlist param;		/* with next ptr null */
struct paramlist {
        paramlist next;
        char      *type;
        char      *name;
};

struct shapelist;
typedef struct shapelist *shapelist;
typedef shapelist shape;		/* with next ptr null */
struct shapelist {
        shapelist next;
        char      *name;
        paramlist params;
};

struct declnlist;
typedef struct declnlist *declnlist;
typedef declnlist decln;		/* with next ptr null */
struct declnlist {
        declnlist next;
        char      *name;
        shapelist shapes;
};

extern paramlist build_paramlist( char * type, char * id, paramlist next );
extern shapelist build_shapelist( char * id, paramlist p, shapelist next );
extern declnlist build_declnlist( char * name, shapelist s, declnlist next );
extern void print_paramlist( FILE *, paramlist p );
extern void print_shapelist( FILE *, shapelist s );
extern void print_declnlist( FILE *, declnlist d );
